<?php

/*
Version 1.1
*/

define('ACCESS_DIR',"./access/");

// 何分以内はカウントしない？
define('UNCOUNT',10);

define('MAX', 1000);

function plugin_access_init(){
	
}

function plugin_access_convert(){
	$ret = readlog();
	$timestamp = $ret[0];
	$ip = $ret[1];
	$host = $ret[2];
	$user_agent = $ret[3];
	
	if (!IsSame(time(),$timestamp[count($timestamp) - 1],$ip[count($ip) - 1])){
		$timestamp[] = time();
		$ip[] = getenv("REMOTE_ADDR");
		// $host[] = getenv("REMOTE_HOST");
		$host[] = gethostbyaddr(getenv("REMOTE_ADDR"));
		$user_agent[] = getenv("HTTP_USER_AGENT");
		
		writelog($timestamp,$ip,$host,$user_agent);
	}
}

function readlog(){
	global $vars;
	global $timestamp,$ip,$host,$user_agent;

	//ログファイル名は？
	if ($vars["page"] != "")
		$filename = ACCESS_DIR.encode($vars["page"]).".acc";
	else
		$filename = ACCESS_DIR.encode($vars["refer"]).".acc";

	//ファイルがある？ない？なければ作る。
	if(!file_exists($filename))
	{
		$nf = fopen($file, "w");
		fputs($nf,"\n");
		fclose($nf);
	}
	
	$array = file($filename);

	for ($i=0;$i < count($array);$i++){
		if ($array[$i] == "")
			continue;
		list($timestamp[],$ip[],$host[],$user_agent[]) = explode('__||__',$array[$i]);
	}
	
	$ret = array($timestamp,$ip,$host,$user_agent);
	return $ret;
}

function writelog($timestamp,$ip,$host,$user_agent){
	global $vars;

	
	$buf = "";
	if(count($timestamp) > MAX){
		for ($i = count($timestamp) - MAX;$i < count($timestamp);$i++){
			$buf .= "$timestamp[$i]__||__$ip[$i]__||__$host[$i]__||__$user_agent[$i]||改行||";
		}
	}else{
		for ($i = 0;$i < count($timestamp);$i++){
			$buf .= "$timestamp[$i]__||__$ip[$i]__||__$host[$i]__||__$user_agent[$i]||改行||";
		}
	}

	$buf = str_replace("\n","",$buf);
	$buf = str_replace("\r","",$buf);
	$buf = str_replace("||改行||", "\n", $buf);

	if ($vars["page"] != "")
		$filename = ACCESS_DIR.encode($vars["page"]).".acc";
	else
		$filename = ACCESS_DIR.encode($vars["refer"]).".acc";

	$fp = fopen($filename, "w");	# ログファイルオープン
	flock($fp, 2);
	fputs($fp, $buf);
	fclose($fp);
}

function IsSame($nowtime,$lasttime,$lastip){
	global $timestamp,$ip,$host,$user_agent;

	Debug("min",$lasttime + UNCOUNT * 60);
	Debug("now",$nowtime);

	if ($lastip == getenv("REMOTE_ADDR")){
		Debug("IsSame","same");
		return true;
	}else{
		Debug("IsSame","diff");
		return false;
	}
}

function Debug($key,$msg){
	// echo "$key : $msg<br>";
}

?>